<?php


class cpsmart_otp
{
    protected $loader;

    protected $plugin_name;

    protected $version;

    public function __construct()
    {
        if (defined('CPOTP_VERSION')) {
            $this->version = CPOTP_VERSION;
        } else {
            $this->version = '1.0.0';
        }
        $this->plugin_name = 'cpsmart_otp';

        $this->load_dependencies();
        $this->set_locale();
        $this->define_admin_hooks();
        $this->define_public_hooks();
    }

    private function load_dependencies()
    {
        require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-cp_smart_otp-loader.php';

        require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-cp_smart_otp-i18n.php';

        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-cp_smart_otp-admin.php';

        require_once plugin_dir_path(dirname(__FILE__)) . 'public/class-cp_smart_otp-public.php';

        $this->loader = new cpsmart_otp_loader();
    }

    private function set_locale()
    {
        $plugin_i18n = new cpsmart_otp_i18n();

        $this->loader->add_action('plugins_loaded', $plugin_i18n, 'load_plugin_textdomain');
    }


    private function define_admin_hooks()
    {
        $plugin_admin = new cpsmart_otp_admin($this->get_plugin_name(), $this->get_version());

        $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_styles');
        $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts');
    }

    private function define_public_hooks()
    {
        $plugin_public = new cpsmart_otp_public($this->get_plugin_name(), $this->get_version());

        $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_styles');
        $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_scripts');
    }


    public function run()
    {
        $this->loader->run();
    }

    public function get_plugin_name()
    {
        return $this->plugin_name;
    }

    public function get_loader()
    {
        return $this->loader;
    }

    public function get_version()
    {
        return $this->version;
    }
}
