var AccountKit_OnInteractive;

;(function ($) {
    'use strict';
    AccountKit_OnInteractive = function () {
        AccountKit.init({
            appId: CpOtp.app_id,
            state: CpOtp.nonce,
            version: CpOtp.version,
            display: CpOtp.app_display,
            fbAppEventsEnabled: true,
        });
    };


    // login callback
    CpOtp.loginCallback = function (response) {
        if (typeof CpOtp.currentForm !== 'object' && CpOtp.currentForm.length <= 0) return;

        var $message = $( '.wpcf7-response-output', CpOtp.currentForm);

        if (response.status === "PARTIALLY_AUTHENTICATED") {
            var data = {
                fb_code: response.code,
                csrf: response.csrf,
                action: 'cpotp-cf7',
                cf7_data: CpOtp.currentForm.serialize(),
                referral: location.href
            };

            var href = CpOtp.ajaxurl + "?";
            href += $.param(data);

            $.get(href, function (res) {
                if (res.success) {

                    $message.addClass('wpcf7-mail-sent-ok');
                    $message.html( '' ).append( res.data.message ).slideDown( 'fast' );

                    CpOtp.currentForm.find('.cpotp_button_cf7').closest('span').find('[role="alert"]').remove();

                    CpOtp.currentForm.find('[name="cpotp_button_email"]').val(res.data.result.email);
                    CpOtp.currentForm.find('[name="cpotp_button_phone"]').val(res.data.result.phone);

                    if (CpOtp.currentForm.find('[name="cpotp_log_id"]').length === 0) {
                        CpOtp.currentForm.append("<input name='cpotp_log_id' type='hidden' />");
                    }
                    CpOtp.currentForm.find('[name="cpotp_log_id"]').val(res.data.result.id);

                    CpOtp.currentForm.trigger('submit');
                } else {
                    $message.addClass('wpcf7-validation-errors');
                    $message.html( '' ).append( res.data.message ).slideDown( 'fast' );
                }
            }).done(function () {

            });
        } else if (response.status === "NOT_AUTHENTICATED") {
        } else {
            $message.addClass('wpcf7-aborted');
            $message.html( '' ).append( CpOtp.i18n.cf7.verify_canceled ).slideDown( 'fast' );
        }
    };

    CpOtp.fblogin_email = function (event) {
        event.preventDefault();
        var $el = $(event.target);
        var $form = $el.closest('form');
        CpOtp.currentForm = $form;

        var email = $form.find('[type="email"]').val();
        AccountKit.login('EMAIL', {
            emailAddress: email
        }, CpOtp.loginCallback);
    };

    CpOtp.fblogin_sms = function (event) {
        event.preventDefault();
        var $el = $(event.target);
        var $form = $el.closest('form');
        CpOtp.currentForm = $form;

        var phone = $form.find('[type="tel"]').val();
        var countryCode = $el.data('country-code');
        countryCode = countryCode ? countryCode : '';

        AccountKit.login('PHONE', {
            phoneNumber: phone,
            countryCode: countryCode
        }, CpOtp.loginCallback);
    };

})(jQuery);
