var AccountKit_OnInteractive;

;(function ($) {
    'use strict';
    AccountKit_OnInteractive = function () {
        AccountKit.init({
            appId: CpOtp.app_id,
            state: CpOtp.nonce,
            version: CpOtp.version,
            fbAppEventsEnabled: true,
            display: CpOtp.app_display
        });
    };

    CpOtp.form_name = '';
    // login callback
    CpOtp.loginCallback = function (response) {

        if (response.status === "PARTIALLY_AUTHENTICATED") {
            var data = {
                code: response.code,
                csrf: response.csrf,
                action: 'fb_account_kit_associate'
            };

            var href = CpOtp.ajaxurl + "?";
            href += $.param({
                "action": "cp-fb-verify",
                "fb_code": data.code,
                "referral": location.href,
                "form_name": CpOtp.form_name
            });

            $.get(href, function (res) {
                if (res.success) {
                    location.href = CpOtp.redirect_after_login;
                } else {
                    alert(res.data.message);
                }
            });
        } else if (response.status === "NOT_AUTHENTICATED") {
        } else {
            console.log(response);
            alert("Error: 0000x1");
        }
    };

    CpOtp.fblogin_email = function (event, formName) {
        event.preventDefault();
        if ($(event.target).closest('form').hasClass('woocommerce-form')) {
            formName = 'woocommerce_login';
        }
        CpOtp.form_name = formName;
        AccountKit.login('EMAIL', {}, CpOtp.loginCallback);
    };
    CpOtp.fblogin_sms = function (event, formName) {
        event.preventDefault();
        var $el = $(event.target);
        if ($el.closest('form').hasClass('woocommerce-form')) {
            formName = 'woocommerce_login';
        }
        CpOtp.form_name = formName;

        var countryCode = $el.data('country-code');
        countryCode = countryCode ? countryCode : '';

        AccountKit.login('PHONE', {
            countryCode: countryCode
        }, CpOtp.loginCallback);
    };

    $('.login').addClass('cpOtp-login');
    $('.cpOtp-switch-login').on('click', '.cpOtp-switch-default',function () {
        $('.cpOtp-login').removeClass('cpOtp-login');
    });
    $('.cpOtp-switch-login').on('click', '.cpOtp-switch-cp', function () {
        $('.login').addClass('cpOtp-login');
    });

})(jQuery);
